package sit;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.UnknownHostException;
import java.util.Arrays;

/**
 *
 * @author zak
 */
public class SitoveRozhrani {

    private String url;
    private String cistyVstup;
    private int idHry;
    private int typ;
    private int zbyvaTahu;
    private String hraciPole = "";
    private int[] hrac1;
    private int[] hrac2;
    private boolean hraje = true;
    private int skore;

    public SitoveRozhrani(String url) throws MalformedURLException, UnknownHostException, IOException {
        this.url = url;
        url += "/start";
        URL startUrl = new URL(url);
        BufferedReader br = new BufferedReader(new InputStreamReader(startUrl.openStream()));
        String strDocasny = "";

        int pocitadlo = 0;
        while (null != (strDocasny = br.readLine())) {
            //System.out.println(pocitadlo + strDocasny);
            switch (pocitadlo) {
                case 0: {
                    idHry = Integer.parseInt(strDocasny);
                    break;
                }

                case 1: {
                    zbyvaTahu = Integer.parseInt(strDocasny);
                    break;
                }

                case 12: {
                    String[] docasne = strDocasny.split(" ");
                    //System.out.println(Arrays.toString(docasne));
                    hrac1 = new int[4];
                    for (int i = 0; i < 4; i++) {
                        hrac1[i] = Integer.parseInt(docasne[i]);
                    }
                    break;
                }

                case 13: {
                    if (!strDocasny.isEmpty()) {
                        typ = 2;
                        String[] docasne = strDocasny.split(" ");
                        hrac2 = new int[4];
                        for (int i = 0; i < 4; i++) {
                            hrac2[i] = Integer.parseInt(docasne[i]);
                        }
                    } else {
                        typ = 1;
                    }
                    break;
                }

                default: {
                    hraciPole += strDocasny + "\n";
                }
            }
            pocitadlo++;
        }
    }

    public void tah(Smery smer) throws MalformedURLException, IOException {
        String strTahUrl = url + "/tah?id=" + idHry + "&pohyb=";        
        switch (smer) {
            case NAHORU: {                
                if(overPrazdno(Smery.NAHORU) && (hrac1[1] != 1)) {
                    strTahUrl += "N";
                } else {
                    throw new IllegalArgumentException("Nepovolený tah");
                }                
                break;
            }

            case DOLU: {
                if(overPrazdno(Smery.DOLU) && (hrac1[1] != 10)) {
                    strTahUrl += "D";
                } else {
                    throw new IllegalArgumentException("Nepovolený tah");
                }
                break;
            }

            case DOLEVA: {
                if(overPrazdno(Smery.DOLEVA) && (hrac1[0] != 1)) {
                    strTahUrl += "L";
                } else {
                    throw new IllegalArgumentException("Nepovolený tah");
                }
                break;
            }

            case DOPRAVA: {
                if(overPrazdno(Smery.DOPRAVA) && (hrac1[0] != 10)) {
                    strTahUrl += "P";
                } else {
                    throw new IllegalArgumentException("Nepovolený tah");
                }
                break;
            }
        }
        URL tahUrl = new URL(strTahUrl);
        vyhodnotTah(tahUrl);
    }

    private void vyhodnotTah(URL url) throws IOException {
        hraciPole = "";
        BufferedReader br = new BufferedReader(new InputStreamReader(url.openStream()));
        String strDocasny = "";

        int pocitadlo = 0;

        while (null != (strDocasny = br.readLine())) {
            //System.out.println(pocitadlo + strDocasny);
            switch (pocitadlo) {
                case 0: {
                    if (strDocasny.contains("Konec hry:")) {
                        hraje = false;
                        skore = Integer.parseInt(strDocasny.split(" ")[2]);
                    }
                    break;
                }

                case 1: {
                    zbyvaTahu = Integer.parseInt(strDocasny);
                    break;
                }

                case 12: {
                    String[] docasne = strDocasny.split(" ");
                    //System.out.println(Arrays.toString(docasne));
                    hrac1 = new int[4];
                    for (int i = 0; i < 4; i++) {
                        hrac1[i] = Integer.parseInt(docasne[i]);
                    }
                    vlozHrace(1);
                    break;
                }

                case 13: {
                    if (!strDocasny.isEmpty()) {
                        String[] docasne = strDocasny.split(" ");
                        hrac2 = new int[4];
                        for (int i = 0; i < 4; i++) {
                            hrac2[i] = Integer.parseInt(docasne[i]);
                        }
                        vlozHrace(2);
                    }                    
                    break;
                }

                default: {
                    hraciPole += strDocasny + "\n";
                }
            }
            pocitadlo++;
        }        
    }

    private void vlozHrace(int hrac) {
        int pozice = spocitejPoziciHrace(hrac);
        //System.out.println("Pozice: " + pozice);
        //System.out.println("Substr: \n" + hraciPole.substring(0, pozice) + "\n END");
        String[] hraci = {"@@", "ĐĐ"};
        hraciPole = hraciPole.substring(0, pozice) + hraci[hrac - 1] + hraciPole.substring(pozice + 2);
    }

    private int spocitejPoziciHrace(int hrac) {
        int s = 0;
        int r = 0;
        switch (hrac) {
            case 1: {
                s = hrac1[0];
                r = hrac1[1];
                break;
            }
            case 2: {
                s = hrac2[0];
                r = hrac2[1];
                break;
            }
        }
        s--;
        r--;
        return (r * 21) + (s * 2);
    }
    
    private boolean overPrazdno(Smery smer) {        
        int pozice = spocitejPoziciHrace(1);        
        switch(smer) {
            case NAHORU : {
                pozice -= 21;
                break;
            }
            case DOLEVA : {
                pozice -= 2;
                break;
            }
            case DOPRAVA : {
                pozice += 2;
                break;
            }
            case DOLU : {
                pozice += 21;
                break;
            }
        }        
        //System.out.println("Smerem: " + hraciPole.substring(pozice, pozice + 2));
        if((pozice < 208) && (pozice >= 0)) {                    
            return (hraciPole.substring(pozice, pozice + 2).matches("(\\.){2}|\\d{2}|\\-{2}|\\+{2}"));
        } else {
            return false;
        }
    }
    
    public String getCistyVstup() {
        return cistyVstup;
    }

    public int getIdHry() {
        return idHry;
    }

    public int getTyp() {
        return typ;
    }

    public int getZbyvaTahu() {
        return zbyvaTahu;
    }

    public String getHraciPole() {
        return hraciPole;
    }

    public int[] getHrac1() {
        return hrac1;
    }

    public int[] getHrac2() {
        return hrac2;
    }

    public boolean isHraje() {
        return hraje;
    }

    public int getSkore() {
        return skore;
    }

}
